#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <conio.h>
#include <bios.h>
#include <time.h>
#include <dos.h>
#include <mem.h>
#include <sys\stat.h>

char  author[] = "1.9 by Jrgen Hoffmann (2010) j_hoff@hrz1.hrz.tu-darmstadt.de";
char *mypath;
char *myname;
char *tmpfnam;
char *tmpfidx;
FILE *tempfil;
FILE *initfil;
char *inipath;
int   iniplen = 0;
int   lineno  = 0;
long  inifpos;
int   debug   = 0;

char *modes[3] ={"CHAR","MONO","COLOR"};
int  mode   = 2;
int  boxwid = 0;
int  tmarg  = 0;
int  lmarg  = 0;
int  bmarg  = 0;
int  cwidth = 0;
int  stl    = 0;

int  scrwid = 80;
int  scrlen = 25;
int  scrmod = C80;

int  dly[2] = { 10,  0 };
long lt0[2] = { 0L, 0L };

int  nhead  = 0;
struct headstruct {
  char *txt;
  char *cmd;
  char *dsp;
  char flags;
  } ;
struct headstruct head[10] = {{NULL,NULL,NULL},{NULL,NULL,NULL},
			      {NULL,NULL,NULL},{NULL,NULL,NULL},
			      {NULL,NULL,NULL},{NULL,NULL,NULL},
			      {NULL,NULL,NULL},{NULL,NULL,NULL},
			      {NULL,NULL,NULL},{NULL,NULL,NULL}};

int  ttcount = 0;
int  btcount = 0;
int  gtcount = 0;

struct testprocedure {
  int   typ; // 0:PTEST 1:NTEST 2:BTEST 3:GTEST
  char *cmd;
  char *test;
  char *disp;
  } ;

struct testprocedure *ttest[10] = {NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
struct testprocedure *btest[10] = {NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
struct testprocedure *gtest[10] = {NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};

struct node {
  struct node  *next;
  struct node  *depends;
  char         *name;
  unsigned char icon;
  unsigned char test;
  unsigned char res;
  unsigned int  count;
  char         *arg;
  char         *status;
  } ;

#define MAXPAGECOUNT 4
int pagecount = 0;
int currpage  = 0;
int hidepage  = 0;
struct node *pages[MAXPAGECOUNT] = {NULL,NULL,NULL,NULL} ;
struct node *lastnode;
struct node *lasthost;
int ncount[MAXPAGECOUNT] = { 0,0,0,0 };
int hilite[MAXPAGECOUNT] = { 0,0,0,0 };
int scrol0[MAXPAGECOUNT] = { 0,0,0,0 };
int scrol1[MAXPAGECOUNT] = { 0,0,0,0 };
int scrol2[MAXPAGECOUNT] = { 0,0,0,0 };
char blank[2] = " ";

char    *wallpaper[MAXPAGECOUNT] = {NULL,NULL,NULL,NULL};
unsigned char pcol[MAXPAGECOUNT] = {1,0,0,0};
unsigned char plsp[MAXPAGECOUNT] = {0,0,0,0};
unsigned char pbox[MAXPAGECOUNT] = {0,0,0,0};
unsigned char maxn[MAXPAGECOUNT] = {0,0,0,0};
unsigned char nicn[MAXPAGECOUNT] = {0,0,0,0};

#define MAXICONS 9
int  nicon = 0;
char iconfile[MAXICONS][16] = {"","","","","","","","",""} ;
long icondate[MAXICONS];
char *htmlpath = NULL;
char *htmlnam;
char *htmlidx;
FILE *htmlfil;
int  htpage  = 0;
int  refresh = 30;
FILE *logfile;
char *logname = NULL;
char *loginfo = NULL;
long  logsize = 0L;

int  maxnam;
int  shcnt = 0;
int  goon  = 1;
int  force = 0;
int  fast  = 0;
long udtim = 0L;
unsigned int rounds = 0;
unsigned int dspcnt = 0;
char life[5] = "-/|\\";
char trbuf[128];

#define NUMKEYWORDS 16
char *keywords[NUMKEYWORDS] = {"GTEST","PTEST","NTEST","BTEST","HEAD","COLS",
			       "HOST","LABEL","MARGIN","PAGE","DELAY","ICON",
			       "HTML","DEPENDS","ALIAS","LOGFILE"};

char hline[42] = "";

/*--- error handling and clean-up ---------------------------------*/

void clear_tempfiles(void) {
  char c;
  if(!tmpfidx||(debug&2)) return;
  for(c='0'; c<='9'; c++) {
    *tmpfidx = c;
    remove(tmpfnam);
    }
  }

void fatal_error(int arg, char *p) {
  static char *ftyp[6] = {"temp","ini","icon","log","wallpaper","html"};
  char buf[128];
  fprintf(stderr,"ERROR: ");
  if(lineno) {
    fprintf(stderr,"in inifile, line: %d: ",lineno);
    if(!(debug&1)) {
      fprintf(stderr,"\n");
      fseek(initfil,inifpos,0);
      if(fgets(buf,126,initfil)!=0) fprintf(stderr,"%d: %s",lineno,buf);
      }
    }
  switch(arg) {
    case  0:
    case  1:
    case  2:
    case  3:
    case  4: 
    case  5: sprintf(buf,"Cannot open %sfile: %s",ftyp[arg],p); break;
    case  6: sprintf(buf,"Page %s is empty",p);                 break;
    case  7: sprintf(buf,"Number out of range: %s",p);          break;
    case  8: sprintf(buf,"Too many entries of type: %s",p);     break;
    case  9: sprintf(buf,"Unresolved reference: %s",p);         break;
    case 10: sprintf(buf,"%s expected",p);                      break;
    case 11: sprintf(buf,"Unknown keyword: %s",p);              break;
    case 12: sprintf(buf,"Bad number: %s",p);                   break;
    case 13: sprintf(buf,"Number out of range: %s",p);          break;
    case 14: sprintf(buf,"No path allowed here: %s",p);         break;
    case 15: sprintf(buf,"No such host: %s",p);                 break;
    case 16: sprintf(buf,"Cannot depend on itself: %s",p);      break;
    case 17: sprintf(buf,"Out of memory");                      break;
    case 18: sprintf(buf,"Unsupported DOS version");            break;
    case 19: sprintf(buf,"Global test number %s failed",p);     break;
    case 20: sprintf(buf,"No display page");                    break;
    }
  if(logname) fprintf(logfile,"ERROR: %s\n\n",buf);
  fprintf(stderr,"%s\n\n",buf);
  clear_tempfiles();
  exit(1);
  }

void num_error(int arg1, int arg2) {
  char buf[12];
  sprintf(buf,"%d",arg2);
  fatal_error(arg1,buf);
  }

void dump_data(void) {
  struct node *np;
  int i;
  printf("; %s\n; %s\n;\n",inipath,tmpfnam);
  for(i=0; i<nhead; i++) {
    printf("%-8s\"%s\"",keywords[4],head[i].txt);
    if(head[i].cmd) printf(" \"%s\"",head[i].cmd);
    if(head[i].dsp) printf(" \"%s\"",head[i].dsp);
    printf("\n");
    }
  for(i=0; i<nicon; i++) printf("%-8s\"%s\"\n",keywords[11],iconfile[i]);
  if(htmlpath) printf("%-8s\"%s\"  %d  %d\n",keywords[12],htmlpath,htpage,refresh);
  if(logname) {
    printf("%-8s\"%s\"",keywords[15],logname);
    if(loginfo||logsize) {
      printf(" %d",(logsize>>10));
      if(loginfo) printf(" \"%s\"",loginfo);
      }
    printf("\n");
    }
  printf("%-8s%-2d %-2d %s  %s\n",keywords[5],pcol[0],plsp[0],modes[mode],pbox[0]?"BOX":"");
  printf("%-8s%-2d %-2d %-2d",keywords[8],tmarg,lmarg,bmarg);
  if(wallpaper[0]) printf(" \"%s\"",wallpaper[0]);
  printf("\n");
  printf("%-8s%-2d %-2d",keywords[10],dly[0],dly[1]);
  if(fast) printf(" FASTINI");
  printf("\n");
  for(i=1; i<=gtcount; i++) {
    printf("%-8s\"%s\"",keywords[0],gtest[i]->cmd);
    if(gtest[i]->test) printf(" \"%s\"",gtest[i]->test);
    if(gtest[i]->disp) printf(" \"%s\"",gtest[i]->disp);
    printf("\n");
    }
  for(i=1; i<=btcount; i++) {
    printf("%-8s\"%s\"",keywords[3],btest[i]->cmd);
    if(btest[i]->test) printf(" \"%s\"",btest[i]->test);
    if(btest[i]->disp) printf(" \"%s\"",btest[i]->disp);
    printf("\n");
    }
  for(i=1; i<=ttcount; i++) {
    printf("%-8s\"%s\"",keywords[(ttest[i]->typ)+1],ttest[i]->cmd);
    if(ttest[i]->test) printf(" \"%s\"",ttest[i]->test);
    if(ttest[i]->disp) printf(" \"%s\"",ttest[i]->disp);
    printf("\n");
    }
  if(hidepage) printf("%-8sHIDE\n",keywords[9]);
  for(i=0; i<=pagecount; i++) {
    for(np=pages[i]; np!=NULL; np=np->next) {
      if(!np->test) printf("%-8s\"%s\"",keywords[7],np->name);
      else if(np->test>31) printf("%-8s\"%s\" IS \"%s\"",keywords[14],np->name,np->depends->name);
      else {
	printf("%-8s\"%s\"",keywords[6],np->name);
	if(np->test<16) printf(" %d",np->test);
	else printf(" B%d",(np->test&0x0F));
	printf(" \"%s\"",np->arg);
	}
      if(np->icon) printf(" %d",np->icon);
      printf("\n");
      if(np->depends&&np->test<32) printf("%-8sON \"%s\"\n",keywords[13],np->depends->name);
      }
    if(i<pagecount) {
      printf("%-8s",keywords[9]);
      if(pcol[i+1]) {
	printf("%d %d",pcol[i+1],plsp[i+1]);
	if(pbox[i+1]) printf(" BOX");
	if(wallpaper[i+1]) printf(" \"%s\"",wallpaper[i+1]);
	}
      printf("\n");
      }
    }
  clear_tempfiles();
  exit(2);
  }

/*--- miscellaneous helper routines -------------------------------*/

void show_help(void) {
  char ch;
  clrscr();
  printf("\n%s %s\n\n",myname,author);
  printf("usage: %s [ options ]\n\n",myname);
  printf("valid options are:\n\n");
  printf("     /H /?   print this helptext\n");
  printf("     /V      operate in VGA (EGA) mode with 50 (43) lines\n",myname);
  printf("     /I<fil> define alternate ini-file (default: %s.INI)\n",myname);
  printf("     /D<num> set debug value\n\n");
  printf("     debug value can be combined of:\n\n");
  printf("         1   show ini-file while reading\n");
  printf("         2   keep temp-files on exit\n");
  printf("         4   show ini-data after reading (and exit)\n");
  printf("         8   single-step mode\n");
  printf("        16   clear temp-file before each test\n");
  printf("        32   disable html character translation\n");
  printf("        64   show icon file updates\n\n");
  printf("     set %s_INI   to define alternate ini-file\n",myname);
  printf("     set %s_TMP   to define tmp-file directory\n\n",myname);
  cprintf("  --- press any key to continue ---\r");
  ch = getch();
  cprintf("%-40s\r"," ");
  if((ch==0x1B)||(ch==0x03)) exit(0);
  printf("Syntax of ini-file:\n\n");
  printf("     GTEST   <test-command> <test-string>\n");
  printf("     PTEST   <test-command> <test-string> [ <status-string> ]\n");
  printf("     NTEST   <test-command> <test-string> [ <status-string> ]\n");
  printf("     BTEST   <test-command> <test-string> [ <status-string> ]\n");
  printf("     HEAD    [ <text> [ <env-var> | <head-command> [ <search-string> ] ] ]\n");
  printf("     COLS    <columns> <linespacing> <mode> [BOX] (mode=COLOR,MONO,CHAR)\n");
  printf("     MARGIN  <top margin> <left margin> <bottom margin> [ <wallpaper> ]\n");
  printf("     DELAY   <cycle delay> <inter-test delay> [FASTINI]\n");
  printf("     LABEL   [ <name> [ <icon-num> ] ]\n");
  printf("     HOST    <name> [B]<test-num> <argument> [ <icon-num> ]\n");
  printf("     ALIAS   <name> IS  <host-name> [ <icon-num> ]\n");
  printf("     DEPENDS ON <host-name>\n");
  printf("     PAGE    [ HIDE | <columns> <linespacing> [BOX] [ <wallpaper> ] ]\n");
  printf("     ICON    <filename>\n");
  printf("     HTML    <path\\filename> [ <page> [ <refresh-delay> ] ]\n");
  printf("     LOGFILE <path\\filename> [ <size limit> [ <info string> ] ]\n\n");
  printf("     \\a     in *TEST is replaced by <argument> of HOST\n");
  printf("     \\c     in  HEAD is replaced by result     of <head-command>\n");
  printf("     \\e     in  HEAD is replaced by content    of <env-var>\n");
  printf("     \\t     current time    \\d current date    \\q double quote\n");
  exit(0);
  }

char *get_evar(char *p) {
  char buf[16];
  strcpy(buf,myname);
  strupr(buf);
  strcat(buf,p);
  return(getenv(buf));
  }

char *curr_date(void) {
  struct date da;
  static char mon[13][4] = {"","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
  static char buf[12];
  getdate(&da);
  sprintf(buf,"%d %s %d",da.da_day,mon[da.da_mon],da.da_year);
  return(buf);
  }

char *curr_time(void) {
  struct time tm;
  static char buf[10];
  gettime(&tm);
  sprintf(buf,"%02d:%02d:%02d",tm.ti_hour,tm.ti_min,tm.ti_sec);
  return(buf);
  }

void expand_arg(char *dst, char *src, char *arg) {
  char t, *a;
  while(src&&*src) {
    if(*src != '\\') *dst++ = *src++;
    else {
      src++;
      t = *src++;
      if(strchr("ACDEQT",toupper(t))==NULL) *dst++ = t;
      else {
	if(toupper(t)=='T') a = curr_time();
	else if(toupper(t)=='D') a = curr_date();
	else if(toupper(t)=='Q') a = "\"";
	else a = arg;
	if(a) {
	  strcpy(dst,a);
	  dst += strlen(a);
	  }
	}
      }
    }
  *dst ='\0';
  }

char *strtrim(unsigned char *p) {
  unsigned char *q;
  q = &p[strlen(p)];
  while(--q >= p) {
    if(*q <= ' ') *q = '\0';
    else break;
    }
  while(*p&&(*p<=' ')) p++;
  return(p);
  }

long get_filedate(FILE *fil) {
  struct stat statbuf;
  fstat(fileno(fil), &statbuf);
  return(statbuf.st_atime);
  }

char *store_filename(char *nam, char *ext) {
  char *f1, *f2, *p;
  int   l;
  if(!nam||!*nam) nam = myname;
  if((f1=strrchr(nam,'\\'))==NULL) f1=strchr(nam,':');
  f2=strchr(f1?f1:nam,'.');
  if(f1)  l  = strlen(nam)    + 1 + (f1[1]?0:strlen(myname));
  else    l  = strlen(mypath) + 2 + strlen(nam);
  if(!f2) l += 4;
  if((p=malloc(l))==NULL) fatal_error(17,NULL);
  if(f1) {
    strcpy(p,nam);
    if(!f1[1]) strcat(p,myname);
    }
  else {
    strcpy(p,mypath);
    strcat(p,"\\");
    strcat(p,nam);
    }
  if(!f2) strcat(p,ext);
  strupr(p);
  return(p);
  }

void calculate_geometry(void) {
  cwidth = (scrwid-lmarg) / pcol[currpage];
  shcnt = (cwidth>(maxn[currpage]+5))?4:0;
  boxwid = maxn[currpage]+shcnt+(mode?0:2)+2;
  setmem(hline,40,'');
  hline[boxwid-2] = '\0';
  }

int get_scrlen(void) {
  struct text_info ti;
  gettextinfo(&ti);
  return(ti.screenheight);
  }

/*--- ini-file processing -----------------------------------------*/

char *scanlin(char *p) {
  char *p1;
  static char *p2;
  if(p != NULL) p2 = p;
  while(*p2&&(*p2<=' ')) p2++;
  if(*p2!='"') {
    p1 = p2;
    while(*p2>' ') p2++;
    if(*p2) *p2++ = '\0';
    }
  else {
    p1 = ++p2;
    while(*p2&&(*p2!='"')) p2++;
    if(*p2=='"') *p2++ = '\0';
    }
  return(p1);
  }

int get_number(char *p, int min, int max) {
  int i;
  if(!isdigit(*p)) fatal_error(12,p);
  i = atoi(p);
  if((i<min)||(i>max)) fatal_error(13,p);
  return(i);
  }

struct testprocedure *storetest(int typ, char *p1, char *p2, char *p3) {
  struct testprocedure *tp;
  if((tp=malloc(sizeof(struct testprocedure)))==NULL) fatal_error(17,NULL);
  tp->typ  = typ;
  tp->cmd  = NULL;
  tp->test = NULL;
  tp->disp = NULL;
  if(!p1||(*p1=='\0')) fatal_error(10,"command string");
  if((tp->cmd=malloc(strlen(p1)+2))==NULL) fatal_error(17,NULL);
  strcpy(tp->cmd,p1);
  if(!p2||(*p2=='\0')) fatal_error(10,"test string");
  if((tp->test=malloc(strlen(p2)+2))==NULL) fatal_error(17,NULL);
  strcpy(tp->test,p2);
  if(p3&&*p3) {
    if((tp->disp=malloc(strlen(p3)+2))==NULL) fatal_error(17,NULL);
    strcpy(tp->disp,p3);
    }
  return(tp);
  }

void store_head(struct headstruct *hs, char *p1, char *p2, char *p3) {
  char *q;
  if(p1) {
    hs->flags = 0;
    hs->txt = malloc(strlen(p1)+2);
    if(hs->txt==NULL) fatal_error(17,NULL);
    strcpy(hs->txt,p1);
    for(q=p1; *q; q++) if(*q=='\\') switch(toupper(q[1])) {
      case 'C': hs->flags |=  1; break;
      case 'D': hs->flags |=  8; break;
      case 'E': hs->flags |=  2; break;
      case 'Q': hs->flags |= 16; break;
      case 'T': hs->flags |=  4; break;
      }
    if(hs->flags&0x03) {
      if(!p2||!*p2) fatal_error(10,"additional string");
      hs->cmd = malloc(strlen(p2)+2);
      if(hs->cmd==NULL) fatal_error(17,NULL);
      strcpy(hs->cmd,p2);
      if(p3&&*p3) {
	hs->dsp = malloc(strlen(p3)+2);
	if(hs->dsp==NULL) fatal_error(17,NULL);
	strcpy(hs->dsp,p3);
	}
      }
    }
  }

void store_node(int flg, char *p1, char *p2, char *p3, char *p4) {
  struct node *np, *hsp, *fp;
  char *hp;
  int i,l;
  if((np=malloc(sizeof(struct node)))==NULL) fatal_error(17,NULL);
  np->next = NULL;
  l = strlen(p1);
  if(l>31) l = 31; else if(l<1) l = 1;
  if((np->name=malloc(l+1))==NULL) fatal_error(17,NULL);
  strncpy(np->name,p1,l);
  np->name[l] = '\0';
  if(!flg&&!(*p1)) strcpy(np->name," ");
  np->depends   = NULL;
  np->icon      = 0;
  np->test      = 0;
  np->res       = -1;
  np->count     = 0;
  np->arg       = blank;
  np->status    = blank;
  hp = p2;
  if(flg==1) {
    hp = p4;
    lasthost = np;
    if(toupper(*p2)=='B') np->test = get_number(&p2[1],1,9) + 16;
    else np->test = get_number(p2,1,9);
    if((np->test<16)&&(np->test>ttcount)) fatal_error(9,p2);
    else if((np->test>16)&&((np->test&0x0F)>btcount)) fatal_error(9,p2);
    if(!p3||(*p3=='\0')) fatal_error(10,"argument");
    l = strlen(p3);
    if(l>80) l = 80;
    if((np->arg=malloc(l+1))==NULL) fatal_error(17,NULL);
    strncpy(np->arg,p3,l);
    np->arg[l] = '\0';
    if((np->status=malloc(81))==NULL) fatal_error(17,NULL);
    np->status[0] = '\0';
    }
  else if(flg==2) {
    hp = p4;
    if(strcmp(strupr(p2),"IS")) fatal_error(10,"IS");
    if(lasthost==NULL) fatal_error(10,"HOST");
    for(fp=NULL,i=0; i<=pagecount; i++)
      for(hsp=pages[i]; hsp!=NULL; hsp=hsp->next)
	if(!strcmp(hsp->name,p3))
	  if((hsp->test>0)&&(hsp->test<32)) fp = hsp;
    if(!fp) fatal_error(15,p3);
    np->depends = fp;
    np->test = 32;
    l = strlen(fp->name)+16;
    if((np->arg=malloc(l+1))==NULL) fatal_error(17,NULL);
    sprintf(np->arg,"is an ALIAS of %s",fp->name);
    np->status = fp->status;
    }
  if(*hp) {
    np->icon = get_number(hp,1,9);
    if(np->icon>nicon) fatal_error(9,hp);
    nicn[pagecount]++;
    }
  ncount[pagecount]++;
  if(lastnode==NULL) pages[pagecount] = np;
  else lastnode->next = np;
  lastnode = np;
  }

void store_icon(char *p) {
  FILE *icf;
  char buf[256];
  if(!p||(*p=='\0')) fatal_error(10,"filename");
  if(strchr(p,'\\')||strchr(p,':')) fatal_error(14,p);
  strncpy(iconfile[nicon],p,15);
  iconfile[nicon][15] = '\0';
  strupr(iconfile[nicon]);
  buf[0] = '\0';
  strncat(buf,inipath,iniplen);
  strcat(buf,iconfile[nicon]);
  if(NULL==(icf=fopen(buf,"r"))) fatal_error(2,buf);
  else {
    icondate[nicon] = get_filedate(icf);
    fclose(icf);
    }
  nicon++;
  }

void store_wallpaper(char *p, int i) {
  FILE *wpf;
  char buf[256];
  if(strchr(p,'\\')||strchr(p,':')) fatal_error(14,p);
  if((wallpaper[i]=malloc(strlen(p)+1))==NULL) fatal_error(17,NULL);
  strcpy(wallpaper[i],p);
  strupr(wallpaper[i]);
  buf[0] = '\0';
  strncat(buf,inipath,iniplen);
  strcat(buf,wallpaper[i]);
  if(NULL==(wpf=fopen(buf,"r"))) fatal_error(4,buf);
  else fclose(wpf);
  }

void store_dependency(char *p1, char *p2) {
  int i;
  struct node *hp, *fp;
  if(strcmp(strupr(p1),"ON")) fatal_error(10,"ON");
  if(lasthost==NULL) fatal_error(10,"HOST");
  for(fp=NULL,i=0; i<=pagecount; i++)
    for(hp=pages[i]; hp!=NULL; hp=hp->next)
      if(!strcmp(hp->name,p2))
	if((hp->test>0)&&(hp->test<32)) fp = hp;
  if(!fp) fatal_error(15,p2);
  if(fp==lasthost) fatal_error(16,p2);
  lasthost->depends = fp;
  }

void read_inifile(void) {
  int i,j,k;
  char *p[5], *q, buf[256];
  if((q=strrchr(inipath,'\\'))==NULL) q=strchr(inipath,':');
  if(q) iniplen = q-inipath + 1;
  lastnode = NULL;
  lasthost = NULL;
  while(!feof(initfil)) {
    buf[0] = '\0';
    inifpos = ftell(initfil);
    fgets(buf,254,initfil);
    lineno++;
    if(debug&1) fprintf(stderr,"%2d: %s",lineno,buf);
    p[0] = scanlin(buf);
    if(*p[0]&&(*p[0]!=';')) {
      strupr(p[0]);
      for(i=1; i<5; i++) p[i] = scanlin(NULL);
      for(i=j=0; i<NUMKEYWORDS; i++) if(!strcmp(keywords[i],p[0])) j = i + 1;
      switch(j) {
	case  1: // GTEST
		 if(gtcount>=9) fatal_error(8,p[0]);
		 gtcount++;
		 gtest[gtcount] = storetest(3,p[1],p[2],p[3]);
		 break;
	case  2: // PTEST
		 if(ttcount>=9) fatal_error(8,"PTEST/NTEST");
		 ttcount++;
		 ttest[ttcount] = storetest(0,p[1],p[2],p[3]);
		 break;
	case  3: // NTEST
		 if(ttcount>=9) fatal_error(8,"PTEST/NTEST");
		 ttcount++;
		 ttest[ttcount] = storetest(1,p[1],p[2],p[3]);
		 break;
	case  4: // BTEST
		 if(btcount>=9) fatal_error(8,p[0]);
		 btcount++;
		 btest[btcount] = storetest(2,p[1],p[2],p[3]);
		 break;
	case  5: // HEAD
		 if(nhead>=9) fatal_error(8,p[0]);
		 store_head(&head[nhead],p[1],p[2],p[3]);
		 nhead++;
		 break;
	case  6: // COLS
		 pcol[0] = get_number(p[1],1,10);
		 plsp[0] = get_number(p[2],0,5);
		 strupr(p[3]);
		 for(i=k=0; i<3; i++) if(!strcmp(modes[i],p[3])) k = i + 1;
		 if(k) mode = k - 1;
		 else fatal_error(11,p[3]);
		 if(*p[4]) {
		   strupr(p[4]);
		   if(!strcmp(p[4],"BOX")) pbox[0] = 1;
		   else fatal_error(11,p[4]);
		   }
		 break;
	case  7: // HOST
		 store_node(1,p[1],p[2],p[3],p[4]);
		 break;
	case  8: // LABEL
		 store_node(0,p[1],p[2],p[3],p[4]);
		 break;
	case  9: // MARGIN
		 tmarg = get_number(p[1],0,5);
		 lmarg = get_number(p[2],0,30);
		 bmarg = get_number(p[3],0,5);
		 if(*p[4]) store_wallpaper(p[4],0);
		 break;
	case 10: // PAGE
		 if(!stricmp(p[1],"HIDE")) hidepage = 1;
		 else {
		   if(!ncount[pagecount]) fatal_error(10,"HOST, ALIAS or LABEL");
		   pagecount++;
		   if(pagecount>=MAXPAGECOUNT)fatal_error(8,p[0]);
		   lastnode = NULL;
		   if(*p[1]) {
		     q = p[3];
		     pcol[pagecount] = get_number(p[1],1,10);
		     plsp[pagecount] = get_number(p[2],0,5);
		     if(!stricmp(q,"BOX")) { pbox[pagecount] = 1; q = p[4]; }
		     if(*q) store_wallpaper(q,pagecount);
		     }
		   }
		 break;
	case 11: // DELAY
		 dly[0] = get_number(p[1],0,180);
		 dly[1] = get_number(p[2],0,10);
		 if(p[3]&&!stricmp(p[3],"FASTINI")) fast = 1;
		 break;
	case 12: // ICON
		 if(nicon>=MAXICONS) fatal_error(8,p[0]);
		 store_icon(p[1]);
		 break;
	case 13: // HTML
		 if(htmlpath) fatal_error(8,p[0]);
		 if(!*p[1]) fatal_error(10,"filename");
		 htmlpath=store_filename(p[1],".HTM");
		 if(*p[2]) {
		   htpage = get_number(p[2],0,4);
		   if(*p[3]) refresh = get_number(p[3],0,300);
		   if((refresh>0)&&(refresh<10)) refresh = 10;
		   }
		 break;
	case 14: // DEPENDS
		 store_dependency(p[1],p[2]);
		 break;
	case 15: // ALIAS
		 store_node(2,p[1],p[2],p[3],p[4]);
		 break;
	case 16: // LOGFILE
		 if(logname) fatal_error(8,p[0]);
		 if(!*p[1]) fatal_error(10,"filename");
		 logname=store_filename(p[1],".LOG");
		 if(*p[2]) logsize = get_number(p[2],0,0x7FFF) * 1024L;
		 if(*p[3]) {
		   if((loginfo=malloc(strlen(p[3])+1))==NULL) fatal_error(17,NULL);
		   strcpy(loginfo,p[3]);
		   }
		 break;
	default: fatal_error(11,p[0]);
		 break;
	}
      }
    }
  if(!ncount[pagecount]) num_error(6,pagecount+1);
  if(pagecount<hidepage) fatal_error(20,NULL);
  fclose(initfil);
  lineno = 0;
  }

/*--- display routines --------------------------------------------*/

void show_head(void) {
  int i, n;
  char buf[256], lin[256], *p;
  char errtxt[] = "--- ERROR ---";
  FILE *rf;
  gotoxy(1,1);
  textattr(0x70);
  cprintf(" %s %s",myname,author);
  clreol();
  textattr(0x07);
  for(i=0; i<nhead; i++) {
    gotoxy(1,i+2);
    if(!head[i].flags) cprintf("%s",head[i].txt);
    else {
      if(head[i].flags&2) {         // \E
	p = getenv(strupr(head[i].cmd));
	if(!p) p = errtxt;
	expand_arg(buf,head[i].txt,p);
	}
      else if(head[i].flags&1) {    // \C
	*tmpfidx = '0';
	strcpy(buf,head[i].cmd);
	strcat(buf," > ");
	strcat(buf,tmpfnam);
	n = system(buf);
	if(n) expand_arg(buf,head[i].txt,errtxt);
	else {
	  if((rf=fopen(tmpfnam,"rt"))==NULL) expand_arg(buf,head[i].txt,errtxt);
	  else {
	    while(!feof(rf)) {
	      fgets(lin,250,rf);
	      p = strtrim(lin);
	      if((!head[i].dsp&&strlen(p))||(head[i].dsp&&strstr(lin,head[i].dsp)))
		    expand_arg(buf,head[i].txt,p);
	      }
	    fclose(rf);
	    }
	  }
	}
      else if(head[i].flags&0x1C) expand_arg(buf,head[i].txt,NULL);
      cprintf("%s",buf);
      }
    clreol();
    }
  stl = wherey() + 1;
  }

void show_status(int ln, char *p) {
  if(stl > 0) {
    gotoxy(1,stl+ln);
    textattr(0x70);
    cprintf("  %s",p);
    clreol();
    textattr(0x07);
    gotoxy(2,stl+ln);
    }
  }

void busy_indicator(int flg) {
  gotoxy(scrwid-5,scrlen);
  textattr(0x70);
  switch(flg) {
    case 0: cprintf("    ");  break;
    case 1: cprintf("busy");  break;
    case 2: cprintf("stp1");  break;
    case 3: cprintf("stp2");  break;
    case 4: cprintf("stp3");  break;
    }
  textattr(0x07);
  }

void single_step(int i) {
  busy_indicator(i+1);
  while(!kbhit());
  if(getch()==0x1B) debug &= 0XFFF7;
  if(i==1) busy_indicator(1);
  else     busy_indicator(0);
  gotoxy(2,stl+1);
  }

void show_res(struct node *np, int hi) {
  int w;
  if(!np->test) {
    textattr(hi?0x70:0x07);
    cprintf("%s",np->name);
    }
  else switch(mode) {
    case 0: // CHAR
	    textattr(hi?0x70:0x07);
	    if(np->count<3)  cprintf("? %s",np->name);
	    else if(np->res) cprintf("- %s",np->name);
	    else             cprintf("+ %s",np->name);
	    break;
    case 1: // MONO
	    if(np->count<3)  textattr(hi?0xF0:0x87);
	    else if(np->res) textattr(hi?0x70:0x07);
	    else             textattr(hi?0x7F:0x0F);
	    cprintf("%s",np->name);
	    break;
    case 2: // COLOR
	    if(np->count<3)  textattr(hi?0x7E:0x0E);
	    else if(np->res) textattr(hi?0x7C:0x0C);
	    else             textattr(hi?0x7A:0x0A);
	    cprintf("%s",np->name);
	    break;
    }
  textattr(0x07);
  }

void draw_box(int x, int y, struct node *np) {
  unsigned char at;
  if(np->test) {
    at = 0x07;
    if(mode==1) {
      if(!np->res) at = 0x0F;
      }
    else if(mode==2) {
      if(np->count<3)  at = 0x0E;
      else if(np->res) at = 0x0C;
      else             at = 0x0A;
      }
    gotoxy(x,y-1);
    textattr(at); cprintf("%s",hline); textattr(0x07);
    gotoxy(x,y+1);
    textattr(at); cprintf("%s",hline); textattr(0x07);
    gotoxy(x+boxwid-1,y);
    textattr(at); cprintf(""); textattr(0x07);
    gotoxy(x,y);
    textattr(at); cprintf(""); textattr(0x07);
    }
  }

void dsp_service(void) {
  struct node *np;
  char buf[82];
  int i,n,x,y;
  if((!wallpaper[currpage]||!wallpaper[currpage][0])&&!debug)
    for(y=stl+2; y<(stl+tmarg+2); y++) {
      gotoxy(1,y);
      clreol();
      }
  for(i=1,np=pages[currpage]; (np!=NULL)&&(i<=scrol0[currpage]); np=np->next,i++);
  for(n=0,y=stl+tmarg+2; np!=NULL; np=np->next,i++,n++) {
    if(n>=pcol[currpage]) { n=0; y+=(1+plsp[currpage]); if(y>=(scrlen-bmarg)) break; }
    if(i==hilite[currpage]) {
      if(!np->test) strcpy(buf,np->name);
      else sprintf(buf,"%s: %s",np->name,np->arg);
      show_status(0,buf);
      show_status(1,np->status);
      lastnode = np;
      }
    x = lmarg+(n*cwidth)+1;
    if(pbox[currpage]) draw_box(x,y,np);
    gotoxy(x+pbox[currpage],y);
    if(shcnt) {
      if(!np->test) gotoxy(x+pbox[currpage]+4,y);
      else cprintf("%3d ",np->count);
      }
    show_res(np,(i==hilite[currpage]));
    if((pcol[currpage]==1)&&(np->test>0)) {
      gotoxy(lmarg+shcnt+maxn[currpage]+2+(!mode?2:0),y);
      cprintf("%s",np->status);
      clreol();
      }
    }
  scrol2[currpage] = i - 1;
  gotoxy(1,scrlen);
  textattr(0x70);
  clreol();
  if(pagecount>hidepage) cprintf(" Pg%d  <Pg\030\031> switch page  ",currpage-hidepage+1);
  cprintf(" <Home> unselect  <\033\030\031\032> select");
  gotoxy(scrwid-20,scrlen);
  cprintf(" <ESC> quit %c%c",life[rounds&3],life[dspcnt&3]);
  textattr(0x07);
  busy_indicator(0);
  udtim = biostime(0,0l);
  dspcnt++;
  }

void clear_display(void) {
  FILE *wpf;
  unsigned char line[82];
  int i,j,wp;
  wp = 0;
  if(wallpaper[currpage]) {
    line[0] = '\0';
    strncat(line,inipath,iniplen);
    strcat(line,wallpaper[currpage]);
    if((wpf=fopen(line,"rb"))!=NULL) wp = 1;
    if(wp) for(i=0; i<scrol1[currpage]; i++) fgets(line,82,wpf);
    }
  for(i=stl+2; i<scrlen; i++) {
    gotoxy(1,i);
    if(wp&&!feof(wpf))
      if(fgets(line,82,wpf)) {
	for(j=strlen(line); (j>=0)&&(line[j]<16); j--) line[j] = '\0';
	cprintf("%s",line);
	}
    clreol();
    }
  if(wp) fclose(wpf);
  }

/*--- keyboard handling routines ----------------------------------*/

void kbd_service(void) {
  int ch, upd;
  upd = 0;
  if(kbhit()) {
    ch = getch();
    if(ch==0x0D) { force = 1; goon = 0; }
    else if(toupper(ch)=='R') upd = 2;
    else if((ch==0x03)||(ch==0x1B)) goon = 0;
    else if(!ch) {
      ch = getch();
      switch(ch) {
	case 0X47: // cursor home
		   hilite[currpage] = 0;
		   upd = 1;
		   break;
	case 0X48: // cursor up
		   if(hilite[currpage]) {
		     if(hilite[currpage]>pcol[currpage]) hilite[currpage] -= pcol[currpage];
		     else hilite[currpage] = 0;
		     upd = 1;
		     }
		   break;
	case 0X49: // page up
		   currpage--;
		   if(currpage<hidepage) currpage = pagecount;
		   calculate_geometry();
		   upd = 2;
		   break;
	case 0X4B: // cursor left
		   if(hilite[currpage]) {
		     hilite[currpage]--;
		     upd = 1;
		     }
		   break;
	case 0X4D: // cursor right
		   if(hilite[currpage]<ncount[currpage]) {
		     hilite[currpage]++;
		     upd = 1;
		     }
		   break;
	case 0X50: // cursor down
		   if((hilite[currpage]+pcol[currpage])<=ncount[currpage]) {
		     if(!hilite[currpage]) hilite[currpage] = 1;
		     else hilite[currpage] += pcol[currpage];
		     upd = 1;
		     }
		   break;
	case 0X51: // page down
		   currpage++;
		   if(currpage>pagecount) currpage = hidepage;
		   calculate_geometry();
		   upd = 2;
		   break;
	}
      }
    if(upd) {
      if(hilite[currpage]>scrol2[currpage]) {
	scrol0[currpage] += pcol[currpage];
	scrol1[currpage] += plsp[currpage];
	scrol1[currpage] ++;
	upd = 2;
	}
      else if(scrol0[currpage]&&(hilite[currpage]<=scrol0[currpage])) {
	scrol0[currpage] -= pcol[currpage];
	scrol1[currpage] -= plsp[currpage];
	scrol1[currpage] --;
	if(!hilite[currpage]||(scrol0[currpage]<0)) scrol0[currpage] = 0;
	if(!hilite[currpage]||(scrol1[currpage]<0)) scrol1[currpage] = 0;
	upd = 2;
	}
      if(upd>1) clear_display();
      dsp_service();
      }
    }
  }

void kill_time(int i) {
  long t0, t1, t;
  t0 = lt0[i&1];
  t1 = t0 + ((dly[i&1] * 91) / 5);
  if(fast) t1 = t0;
  do {
    t = biostime(0,0l);
    kbd_service();
    } while(goon&&(t>=t0)&&(t<=t1));
  if((t-udtim)>91) dsp_service();
  }

/*--- test routines -----------------------------------------------*/

int perform_test(int idx, struct testprocedure *tp, char *arg, char *st) {
  int n, res;
  FILE *rf;
  char buf[512], lin[128], *p;
  lt0[1] = biostime(0,0L);
  res  = ((tp->typ)==1)?0:1;
  idx += '0';
  *tmpfidx = idx;
  if(!arg||(tp->typ!=2)) {
    if(debug&16) remove(tmpfnam);
    expand_arg(buf,tp->cmd,arg);
    if(tp->typ<3) busy_indicator(1);
    if(hilite[currpage]) {
      if(!lastnode->test) strcpy(lin,lastnode->name);
      else sprintf(lin,"%s: %s",lastnode->name,lastnode->arg);
      show_status(0,lin);
      show_status(1,lastnode->status);
      }
    else {
      show_status(0,buf);
      show_status(1," ");
      }
    if(debug&8) single_step(1);
    strcat(buf," > ");
    strcat(buf,tmpfnam);
    n = system(buf);
    if(tp->typ<3) busy_indicator(0);
    if(debug&8) single_step(2);
    if(n) return(2);
    }
  if(tp->typ==2) {
    if(!arg) return(0);
    if(!hilite[currpage]) show_status(0,tp->cmd);
    }
  expand_arg(buf,tp->test,arg);
  if((rf=fopen(tmpfnam,"rt"))==NULL) return(3);
  while(!feof(rf)) {
    lin[0] = '\0';
    fgets(lin,126,rf);
    if(strstr(lin,buf)) {
      res = ((tp->typ)==1)?1:0;
      break;
      }
    }
  if(st&&(tp->typ<3)) {
    fseek(rf,0L,0);
    if(!tp->disp) buf[0] = '\0';
    else expand_arg(buf,tp->disp,arg);
    while(!feof(rf)) {
      fgets(lin,126,rf);
      p = strtrim(lin);
      if((!buf[0]&&strlen(p))||(buf[0]&&strstr(lin,buf))) {
	if(strlen(p)>76) p[76] = '\0';
	strcpy(st,p);
	}
      }
    show_status(1,hilite[currpage]?lastnode->status:st);
    if(debug&8) single_step(3);
    }
  fclose(rf);
  return(res);
  }

void perform_global_tests(void) {
  char buf[130];
  FILE *rf;
  int i,j;
  j = debug;
  debug |= 16;
  for(i=1; i<=gtcount; i++) if(perform_test(0,gtest[i],NULL,NULL)) {
    gotoxy(1,stl+2);
    if((rf=fopen(tmpfnam,"rt"))!=NULL) {
      while(!feof(rf)) {
	buf[0] = '\0';
	fgets(buf,128,rf);
	fprintf(stderr,"%s",buf);
	}
      fclose(rf);
      }
    num_error(19,i);
    }
  debug = j;
  }

/*--- logging -----------------------------------------------------*/

void cut_logfile(void) {
  FILE *tf;
  struct stat st;
  long k,l,m,n;
  int i;
  char buf[256];
  if((logfile=fopen(logname,"rb"))==NULL) return;
  fstat(fileno(logfile),&st);
  if(st.st_size < logsize) {
    fclose(logfile);
    return;
    }
  k = logsize>>2;
  l = st.st_size - (logsize>>1);
  fseek(logfile,l,0);
  fgets(buf,254,logfile);
  l = ftell(logfile);
  i = 1;
  n = 0L;
  while(i&&(n<k)&&!feof(logfile)) {
    m =ftell(logfile);
    fgets(buf,254,logfile);
    n +=strlen(buf);
    if(strstr(buf,"START-UP")) i = 0;
    }
  if(i) fseek(logfile,l,0);
  else  fseek(logfile,m,0);
  *tmpfidx = '0';
  tf=fopen(tmpfnam,"w");
  if(tf) while(!feof(logfile)) if(fgets(buf,254,logfile)) {
    for(i=strlen(buf)-1; (i>=0)&&(buf[i]<' '); i--) buf[i] = '\0';
    buf[++i] = '\n';
    fputs(buf,tf);
    }
  fprintf(tf,"%s LOGFILE-TRUNCATED %s\n\n",curr_time(),curr_date());
  fclose(tf);
  fclose(logfile);
  sprintf(buf,"copy %s %s",tmpfnam,logname);
  system(buf);
  }

void open_logfile(int flg) {
  if(!logname) return;
  if(logsize) cut_logfile();
  if((logfile=fopen(logname,"a"))==NULL) fatal_error(3,logname);
  if(!flg) fprintf(logfile,"%s START-UP %s %s\n",curr_time(),curr_date(),(loginfo?loginfo:inipath));
  }

void logging(int i, struct node *np) {
  if(!logname) return;
  if((i==np->res)&&(np->count==2)) fprintf(logfile,"%s %-*s (%c)     %s\n",
    curr_time(),maxnam,np->name,(i?'-':'+'),np->status);
  else if((i!=np->res)&&(np->count>2)) fprintf(logfile,"%s %-*s (?) %3d %s\n",
    curr_time(),maxnam,np->name,np->count,np->status);
  }

void close_logfile(int flg) {
  if(!logname) return;
  if(flg) fprintf(logfile,"\n");
  else    fprintf(logfile,"%s SHUT-DOWN %s\n\n",curr_time(),curr_date());
  fclose(logfile);
  }

void check_logfile(void) {
  struct stat st;
  if(!logname) return;
  fflush(logfile);
  if(logsize==0L) return;
  fstat(fileno(logfile),&st);
  if(st.st_size < logsize) return;
  close_logfile(1);
  cut_logfile();
  open_logfile(1);
  }

/*--- html routines -----------------------------------------------*/

void prepare_html(void) {
  int i,j,docopy;
  char cmd[256], *sp, *dp;
  if(!htmlpath) return;
  if((htmlfil=fopen(htmlpath,"wt"))==NULL) fatal_error(5,htmlpath);
  else {
    fclose(htmlfil);
    remove(htmlpath);
    }
  if((htmlnam=strrchr(htmlpath,'\\'))==NULL) htmlnam=strchr(htmlpath,':');
  if(htmlnam) htmlnam++; else htmlnam = htmlpath;
  if(htpage) htmlidx=NULL; else htmlidx = strrchr(htmlnam,'0');
  if(nicon) {
    strcpy(cmd,"copy ");
    strcat(cmd,inipath);
    if((sp=strrchr(cmd,'\\'))==NULL) sp=strchr(cmd,':');
    if(sp) *(++sp) = '\0';
    else sp = &cmd[5];
    memset(sp,' ',15);
    sp[15] = '\0';
    strcat(&sp[15],htmlpath);
    if((dp=strrchr(sp,'\\'))==NULL) dp=strchr(sp,':');
    if(dp) *(++dp) = '\0';
    else dp = &sp[15];
    }
  for(i=j=0; i<nicon; i++) {
    strcpy(dp,iconfile[i]);
    docopy = 0;
    if((htmlfil=fopen(dp,"r"))==NULL) docopy = 1;
    else {
      if(get_filedate(htmlfil)<icondate[i]) docopy = 1;
      fclose(htmlfil);
      if(docopy) remove(dp);
      }
    if(docopy) {
      memset(sp,' ',15);
      strcpy(sp,iconfile[i]);
      sp[strlen(iconfile[i])] = ' ';
      if(debug&64) { j++; fprintf(stderr,"%s\n",cmd); }
      system(cmd);
      }
    }
  if(j) { fprintf(stderr,"--- press any key ---"); getch(); }
  }

unsigned char trtbl[49] = {
    199,252,233,226,228,224,229,231, 234,235,232,239,238,236,196,197,
    201,230,198,244,246,242,251,249, 255,214,220,162,163,165,164,131,
    225,237,243,250,241,209,170,186, 191,183,172,189,188,161,171,187,0 };

int trchr(char *p, int ch) {
  int n;
  ch &= 0xFF;
  if(ch=='<')      n = sprintf(p,"&lt;");
  else if(ch=='>') n = sprintf(p,"&gt;");
  else if(ch=='&') n = sprintf(p,"&amp;");
  else if(ch<128)  n = sprintf(p,"%c",ch);
  else if(ch<176)  n = sprintf(p,"&#%d;",trtbl[ch-128]);
  else if(ch==225) n = sprintf(p,"&szlig;");
  else             n = sprintf(p,"&#183;");
  return(n);
  }

char *trstr(char *p, char *buf) {
  char *q, *s;
  if(debug&32) return(p);
  q =  buf;
  s = &buf[120];
  while(*p&&q<s) q += trchr(q,*p++);
  *q = '\0';
  return(buf);
  }

char *get_screen(int l, char*lin) {
  int i;
  char *p, *q, buf[162];
  p = lin;
  q = &lin[120];
  gettext(1,l,80,l,buf);
  if(debug&32) for(i=0; i<160;      i+=2) *p++ = buf[i];
  else         for(i=0; i<160&&p<q; i+=2)  p  += trchr(p,buf[i]);
  *p = '\0';
  return(strtrim(lin));
  }

char *colors[3] = {"GREEN","RED","YELLOW"};

void multi_column(int pg) {
  struct node *np;
  char *cl;
  int i;
  fprintf(htmlfil,"   <TR VALIGN=MIDDLE ALIGN=CENTER>\n");
  for(i=1,np=pages[pg]; np!=NULL; np=np->next,i++) {
    if(i>pcol[pg]) {
      fprintf(htmlfil,"   </TR>\n   <TR VALIGN=MIDDLE ALIGN=CENTER>\n");
      i = 1;
      }
    if(!np->test) fprintf(htmlfil,"    <TD>");
    else {
      cl = (np->count<3)?colors[2]:colors[np->res&1];
      fprintf(htmlfil,"    <TD BGCOLOR=%s>",cl);
      }
    if(np->icon) fprintf(htmlfil,"<IMG SRC=\"./%s\" VSPACE=5 HSPACE=5><BR>",iconfile[np->icon-1]);
    if((np->name[0]==' ')||(np->name[1]=='\0')) fprintf(htmlfil,"&nbsp;");
    else fprintf(htmlfil,"<STRONG>%s</STRONG>",trstr(np->name,trbuf));
    if(np->test) fprintf(htmlfil,"<BR>%d",np->count);
    fprintf(htmlfil,"</TD>\n");
    }
  fprintf(htmlfil,"   </TR>\n");
  }

void single_column(int pg) {
  struct node *np;
  char *cl;
  for(np=pages[pg]; np!=NULL; np=np->next) {
    if(!np->test) fprintf(htmlfil,"   <TR VALIGN=MIDDLE ALIGN=CENTER>\n");
    else {
      cl = (np->count<3)?colors[2]:colors[np->res&1];
      fprintf(htmlfil,"   <TR BGCOLOR=%s VALIGN=MIDDLE ALIGN=CENTER>\n",cl);
      }
    if(nicn[pg]) {
      if(!np->icon) fprintf(htmlfil,"    <TD></TD>\n");
      else fprintf(htmlfil,"    <TD><IMG SRC=\"./%s\" VSPACE=5 HSPACE=5></TD>\n",iconfile[np->icon-1]);
      }
    if((np->name[0]==' ')||(np->name[1]=='\0')) fprintf(htmlfil,"    <TD>&nbsp;</TD>\n");
    else fprintf(htmlfil,"    <TD><STRONG>%s</STRONG></TD>\n",trstr(np->name,trbuf));
    if(np->test) fprintf(htmlfil,"    <TD>%d</TD>\n",np->count);
    fprintf(htmlfil,"    <TD>%s</TD>\n",trstr(np->status,trbuf));
    fprintf(htmlfil,"   </TR>\n");
    }
  }

void write_html(int hp) {
  int i,j;
  if(pcol[hp]>1) i = pcol[hp];
  else i = nicn[hp]?4:3;
  if(htmlidx) *htmlidx = '1' + hp - hidepage;
  htmlfil=fopen(htmlpath,"wt");
  fprintf(htmlfil,"<HTML>\n <HEAD>\n  <TITLE>LAN Status</TITLE>\n");
  if(refresh) fprintf(htmlfil,"  <META http-equiv=\"refresh\" content=\"%d,URL=%s\">\n",refresh,htmlnam);
  fprintf(htmlfil," </HEAD>\n");
  fprintf(htmlfil," <BODY BGCOLOR=#9F9F9F><FONT SIZE=3 FACE=\"ARIAL, TAHOMA, SANS SERIF\">\n");
  fprintf(htmlfil,"  <FONT FACE=\"ARIAL, TAHOMA, SANS SERIF\"><H1 Align=Center>LAN Status</H1>");
  fprintf(htmlfil,"  <H3 Align=Center>%s&nbsp;&nbsp;%s</H3></FONT>\n",curr_date(),curr_time());
  if(htmlidx&&(pagecount>hidepage)) {
    fprintf(htmlfil,"  <CENTER>");
    for(j=hidepage; j<=pagecount; j++)
      if(j==hp) fprintf(htmlfil,"Page %d ",j-hidepage+1);
      else {
	*htmlidx = '1' + j - hidepage;
	fprintf(htmlfil,"<A HREF=\"%s\">Page %d</A> ",htmlnam,j-hidepage+1);
	}
    fprintf(htmlfil,"</CENTER><P>\n");
    }
  fprintf(htmlfil,"  <CENTER><TABLE>\n");
  fprintf(htmlfil,"   <TR BGCOLOR=#C0C0C0><TH COLSPAN=%d>\n",i);
  fprintf(htmlfil,"    <STRONG>%s %s</STRONG><BR>\n",myname,trstr(author,trbuf));
  for(i=2; i<stl; i++) fprintf(htmlfil,"    %s<BR>\n",get_screen(i,trbuf));
  fprintf(htmlfil,"   </TH></TR>\n");
  if(pcol[hp]>1) multi_column(hp);
  else           single_column(hp);
  fprintf(htmlfil,"  </TABLE></CENTER></FONT>\n </BODY>\n</HTML>\n");
  fclose(htmlfil);
  }

void make_html(void) {
  int i;
  if(!htmlpath) return;
  if(htpage) write_html(htpage-1);
  else if(htmlidx==NULL) write_html(currpage);
  else for(i=hidepage; i<=pagecount; i++) write_html(i);
  }

/*--- main program ------------------------------------------------*/

void main (int argc, char* argv[]) {
  int i,j,m;
  char *p;
  struct node *np;
  if((_osmajor<3)||((_osmajor==3)&&(_osminor<1))) fatal_error(18,NULL);
  if((mypath=malloc(strlen(argv[0])+2))==NULL) fatal_error(17,NULL);
  strcpy(mypath,argv[0]);
  strupr(mypath);
  if((p=strrchr(mypath,'\\'))!=NULL) {
    *p++   = '\0';
    myname = p;
    }
  else if((p=strchr(mypath,':'))!=NULL) {
    p++;
    memmove(&p[1],p,strlen(p)+1);
    *p++   = '\0';
    myname = p;
    }
  else myname = mypath;
  if((p=strchr(myname,'.'))!=NULL) *p = '\0';
  if(strlen(myname)>7) myname[7] = '\0';
  p = get_evar("_TMP");
  if(p==NULL) p = getenv("TEMP");
  if(p==NULL) p = getenv("TMP");
  if(p==NULL) p = mypath;
  if((tmpfnam=malloc(strlen(p)+14))==NULL) fatal_error(17,NULL);
  strcpy(tmpfnam,p);
  p = &tmpfnam[strlen(tmpfnam)-1];
  if(*p != '\\') { *++p = '\\'; *++p = '\0';}
  strcat(tmpfnam,myname);
  strupr(tmpfnam);
  tmpfidx = &tmpfnam[strlen(tmpfnam)];
  strcat(tmpfnam,"0.TMP");
  if((tempfil=fopen(tmpfnam,"wt"))==NULL) fatal_error(0,tmpfnam);
  else {
    fclose(tempfil);
    remove(tmpfnam);
    }
  p = NULL;
  for(i=1; i < argc && ((*argv[i]=='/')||(*argv[i]=='-'));i++) {
    switch (toupper(argv[i][1])) {
      case 'D': debug = atoi(&argv[i][2]);             break;
      case 'I': p = &argv[i][2];                       break;
      case 'V': scrmod = C4350;                        break;
      case 'H':
      case '?': show_help();                           break;
      }
    }
  if(p==NULL) p = get_evar("_INI");
  inipath = store_filename(p,".INI");
  if((initfil=fopen(inipath,"rt"))==NULL) fatal_error(1,inipath);
  else read_inifile();

  if(htpage) htpage += hidepage;
  if(htpage>pagecount+1) htpage = 0;
  if(debug&4) dump_data();
  currpage = hidepage;
  for(i=0; i<=pagecount; i++) {
    if(!pcol[i]) {
      pcol[i] = pcol[0];
      plsp[i] = plsp[0];
      pbox[i] = pbox[0];
      wallpaper[i] = wallpaper[0];
      }
    if((pcol[i]<2)||(plsp[i]<2)||(tmarg<1)||(bmarg<1)) pbox[i] = 0;
    }

  prepare_html();
  open_logfile(0);
  textmode(scrmod);
  scrlen = get_scrlen();
  for(i=maxnam=0; i<=pagecount; i++) {
    cwidth = (scrwid-lmarg) / pcol[i];
    m = (cwidth>31)?31:cwidth-1;
    if(pbox[i]) m--;
    if(mode==0) m -= 2;
    for(np=pages[i]; np!=NULL; np=np->next) {
      if((j=strlen(np->name))>maxnam) maxnam = j;
      if(j>maxn[i]) maxn[i] = j;
      if(j>m) np->name[m] = '\0';
      }
    }
  calculate_geometry();
  clrscr();

  show_head();
  perform_global_tests();
  lastnode = NULL;
  clear_display();
  dsp_service();

/*--- main loop (begin) -------------------------------------------*/
  while(goon) {
    lt0[0] = biostime(0,0L);
    for(i=1; goon&&(i<=btcount); i++) {
      perform_test(i,btest[i],NULL,NULL);
      kill_time(1);
      }
    for(i=0; goon&&(i<=pagecount); i++)
      for(np=pages[i]; goon&&(np!=NULL); np=np->next) if(np->test>0) {
	if((np->count<6)||((rounds&3)==0)||(np->test>=16)) {
	  if(np->test==32) {
	    np->res   = np->depends->res;
	    np->count = np->depends->count;
	    }
	  else if(np->depends&&np->depends->res) {
	    np->res   = np->depends->res;
	    np->count = 0;
	    sprintf(np->status,"depends on %s",np->depends->name);
	    }
	  else {
	    j=perform_test((np->test<16)?0:(np->test)&0x0F,
			   (np->test<16)?ttest[np->test]:btest[(np->test)&0x0F],
			    np->arg,np->status);
	    logging(j,np);
	    if(j==np->res) {
	      if(np->count<999) np->count++;
	      }
	    else { np->res = j; np->count = 1; }
	    kill_time(1);
	    }
	  }
	}
    show_head();
    dsp_service();
    gotoxy(1,stl+1);
    make_html();
    check_logfile();
    kill_time(0);
    if(rounds>3) fast = 0;
    if(force) { goon = 1; force = 0; fast = 1; }
    rounds++;
    }
/*--- main loop (end) ---------------------------------------------*/

  textmode(C80);
  close_logfile(0);
  clear_tempfiles();
  gotoxy(1,25);
  textattr(0x07);
  clreol();
  exit(0);
  }
